<template>
	<div class="introduction row-padding col-padding azure-gradient lightestazure-color">
		<h3 class="hustle medium">{{getLocale('introduction')}}</h3>
		
		<div class="container flex lightestazure-border">
			<div 
				v-for="(step, index) in introduction" 
				class="step column-of-3 row-padding col-padding align-center"
				:class="{
					'completable lightestgreen-color' : !completedSteps[index] && progress[index].percent == 100,
					completed : completedSteps[index],
					locked : index != 0 && !completedSteps[index-1],
				}"
			>
				<div class="inner">
					<div class="text uppercase">
						{{getLocale(step.text)}}
					</div>
					
					<div class="progress">
						<div class="svg-wrapper">
							<svg xmlns="http://www.w3.org/2000/svg" 
								:width="svg_radius*2 + svg_width" :height="svg_radius*2 + svg_width" 
								:viewBox="'-2 -2 '+(svg_radius*2 + svg_width + 4)+' '+(svg_radius*2 + svg_width + 4)"
							>
								<defs>
									<radialGradient id="green-gradient">
										<stop offset="10%" stop-color="black" />
										<stop offset="95%" stop-color="#00FFB3" />
									</radialGradient>
									
									<radialGradient id="blue-gradient">
										<stop offset="10%" stop-color="black" />
										<stop offset="95%" stop-color="#0E2D3F" />
									</radialGradient>
									
									<filter id="box-shadow" filterUnits="userSpaceOnUse">
										<feOffset result="offOut" in="SourceGraphic" dx="0" dy="0" />
										<feGaussianBlur result="blurOut" in="offOut" stdDeviation="2" />
										<feBlend in="SourceGraphic" in2="blurOut" mode="normal" />
									</filter>
								</defs>
								
								<circle 
									v-if="!completedSteps[index]"
									:cx="svg_radius+(svg_width/2)" :cy="svg_radius+(svg_width/2)" 
									:r="svg_radius" stroke-width="1" fill="transparent" 
									:stroke="(index.objective - progress[index].value <= 0)? '#02FBB1' : '#B0F0FD'"
								/>
								
								<circle 
									v-if="completedSteps[index]"
									:cx="svg_radius+(svg_width/2)" :cy="svg_radius+(svg_width/2)" 
									:r="svg_radius" stroke-width="0" fill="url('#blue-gradient')"
								/>
								
								<circle 
									class="complete-button" opacity="0.5"
									v-if="!completedSteps[index] && progress[index].percent >= 100"
									:cx="svg_radius+(svg_width/2)" :cy="svg_radius+(svg_width/2)" 
									:r="svg_radius - 20" stroke-width="0" fill="url('#green-gradient')"
									v-on:click="completeStep(index)"
								/>
								
								<path 
									v-if="!completedSteps[index]"
									v-for="n in step.objective"
									filter="url(#box-shadow)"
									:filter="((step.objective - progress[index].value <= 0) || (n <= progress[index].value))? 'url(#box-shadow)' : ''"
									fill="none" :stroke="(step.objective - progress[index].value <= 0)? '#02FBB1' :  (n <= progress[index].value) ? '#B0F0FD' : '#3B4855'" 
									:stroke-width="svg_width" 
									:d="describeArc((dailyDegrees(step.objective)*(n-1))+svg_width/2, (dailyDegrees(step.objective)*n)-svg_width/2)"
								></path>
							</svg>
							
							<div v-if="!completedSteps[index] && progress[index].percent >= 100" class="rewards-icon" :style="{ 'background-image' : 'url('+getImage('daily-reward.svg')+')' }"></div>
							<div v-if="completedSteps[index]" class="completed-icon" :style="{ 'background-image' : 'url('+getImage('daily-completed.svg')+')' }"></div>
						</div>
						
						<div v-if="!completedSteps[index] && progress[index].percent < 100" class="text">
							{{step.objective - progress[index].value}}
						</div>
						
					</div>
					
					<div class="reward row-padding flex uppercase">
						<div v-if="!completedSteps[index]">
							<div>{{getLocale('reward')}}</div>
							<div class="flex h-center v-center">
								{{getLocale(step.reward)}}
							</div>
						</div>
						<div v-else class="completed-text">
							{{getLocale('completed')}}
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import Vue from 'vue';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	
	import seedrandom from 'seedrandom';
	
	export default {
		data: function () {
			return{
				introduction : [
					{text : 'intro_1_text', reward : 'intro_1_reward', objective : 10},
					{text : 'intro_2_text', reward : 'intro_2_reward', objective : 3},
					{text : 'intro_3_text', reward : 'intro_3_reward', objective : 1},
				],
				svg_radius : 100,
				svg_width : 8,
			}
		},
		computed: {
			completedSteps(){
				return [
					this.checkTutorial('analyzer'),
					this.checkTutorial('network') || this.network_introduction,
					this.checkTutorial('introduction')
				];
			},
			progress(){
				let vairus_progress = this.vairus_list.length;
				
				let nodes_progress = this.grid_nodes.reduce(function(value, node){
					if(node.type != 'builder' || node.data == null) return value;
					 
					return value-4+node.data.structures[0].level+node.data.structures[1].level+node.data.structures[2].level+node.data.structures[3].level;
				}.bind(this), 0);
				
				return [
					{value : vairus_progress, percent : (vairus_progress*100)/10},
					{value : this.analysis_count, percent : (this.analysis_count >= 3)? 100 : this.analysis_count*33},
					{value : nodes_progress , percent :	(nodes_progress > 0)? 100 : 0},
				];
			},
			startOfDay(){
				let now = new Date().getTime();
				return Math.floor((now - (now%(1000*60*60*24)))/1000);
			}
		},
		methods: {
			completeStep(index){
				switch(index){
					case 0: this.setTutorial('analyzer', true, false, 'red'); break;
					case 1: this.$store.commit('setNetworkIntroduction'); break;
					case 2: this.setTutorial('introduction', true); break;
				}
			},
			polarToCartesian(centerX, centerY, radius, angleInDegrees) {
				var angleInRadians = (angleInDegrees-90) * Math.PI / 180.0;

				return {
					x: centerX + (radius * Math.cos(angleInRadians)),
					y: centerY + (radius * Math.sin(angleInRadians))
				};
			},
			describeArc(startAngle, endAngle){
				var start = this.polarToCartesian(this.svg_radius+(this.svg_width/2), this.svg_radius+(this.svg_width/2), this.svg_radius, endAngle);
				var end = this.polarToCartesian(this.svg_radius+(this.svg_width/2), this.svg_radius+(this.svg_width/2), this.svg_radius, startAngle);

				var largeArcFlag = endAngle - startAngle <= 180 ? "0" : "1";

				var d = [
					"M", start.x, start.y, 
					"A", this.svg_radius, this.svg_radius, 0, largeArcFlag, 0, end.x, end.y
				].join(" ");

				return d;       
			},
			dailyDegrees(objective){
				return Math.floor(360/objective*100)/100;
			}
		},
		mixins: [commonMixin, storeGettersMixin],
	}
	
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	.introduction{
		border-radius: 10px;
		padding-bottom: 40px;
		
		h3{
			margin-bottom: 10px;
		}
	
		.title{
			margin-bottom: 20px;
		}
		
		.container{
			position: relative;
			
			.step{
				margin-left: 50px;
				position: relative;
					
				&:first-child{
					margin-left: 0;
				}
				
				&.locked{
					opacity: 0.2;
					pointer-events: none;
				}
				
				.inner > .text{
					height: 40px;
				}
				
				.progress{
					position: relative;
					margin-top: 20px;
					
					.text{
						position: absolute;
						left: 0;
						top: 0;
						width: 100%;
						height: 100%;
						bottom: 0;
						text-align: center;
						line-height: 205px;
						font-size: 5rem;
					}
					
					.svg-wrapper{
						display: inline-block;
						position: relative;
						
						svg{
							display: block;
						}
						
						.complete-button{
							cursor: pointer;
						}
						
						.rewards-icon{
							position: absolute;
							width: 64px;
							height: 64px;
							top: 64px;
							left: 80px;
							background-position: center;
							background-repeat: no-repeat;
							background-size: contain;
							pointer-events: none;
						}
						.completed-icon{
							position: absolute;
							width: 64px;
							height: 64px;
							top: 50%;
							left: 50%;
							transform: translate(-50%,-50%);
							background-position: center;
							background-repeat: no-repeat;
							background-size: contain;
							pointer-events: none;
						}
					}
					
				}
				
				.reward{
					justify-content: center;
					
					.icon{
						margin-left: 5px;
						width: 20px;
						background-size: contain;
						background-repeat: no-repeat;
						background-position: center;
					}
					
					.completed-text{
						width: 100px;
					}
				}
				
			}
			
			.expiration{
				position: absolute;
				bottom: -18px;
				left: 50%;
				transform: translateX(-50%);
			}
		}
	}
	
	@media screen and (max-width: 960px) {
		.introduction .container .step{
			margin-left: 0;
			
			.progress .svg-wrapper svg{
				width: 100%;
			}
		}
	}
	
	@media screen and (max-width: 600px) {
		.introduction .container{
			display: block;
			
			.step{
				width: 100%;
				
				.inner > .text{
					height: auto;
				}
				
				.progress{
					margin-top: 10px;
				}
				.reward{
					padding-top: 10px;
				}
			}
		}
	}
</style>
